package constructs;

import static util.Characters.*;

import file.FilePosition;
import util.Characters;

public class TokenFactoryImpl implements TokenFactory {

    public Token createToken(String text, FilePosition position) {
        char firstCharacter = text.charAt(0);

        switch (firstCharacter) {
        case LEFT_PARENTHESIS:
            return new Token(Token.Type.LEFT_PAREN, text, position);
        case RIGHT_PARENTHESIS:
            return new Token(Token.Type.RIGHT_PAREN, text, position);
        case SINGLE_QUOTE:
            return new Token(Token.Type.QUOTE_MARK, text, position);
        case DOUBLE_QUOTE:
            return new Token(Token.Type.STRING, text, position);
        default:
            if (Character.isDigit(firstCharacter)) {
                return new Token(Token.Type.NUMBER, text, position);
            } else if (Characters.isLegalIdentifierCharacter(firstCharacter)) {
                return new Token(Token.Type.IDENTIFIER, text, position);
            }
        }

        throw new RuntimeException("oh no!");
    }

    public Token createEOFToken(FilePosition position) {
        return new Token(Token.Type.EOF, "EOF", position);
    }

}
